
/**
 * 
 * @author Lorenz Schauer
 * Implementierende Klasse des Interface IHund
 * 
 * Main-Methode zeigt die anderen Mglichkeiten Interfaces zu implementieren. 
 * Aus der Kurstsunde vom 19.01.2017
 *
 */
public class HundImpl implements IHund {

	//Instanzvariable
	private int groesse;
	
	//Konstruktor
	public HundImpl(int groesse){
		this.groesse=groesse;
	}
	


	//Methoden des Interface, die ueberschrieben werden mssen

	@Override
	public void bellen() {

		if(this.groesse>=100)System.out.println("Wau");
		else 
			System.out.println("wuff");
		
	}

	@Override
	public String doAction(int action) {
		
		String out ="";
		
		switch(action){
		case 0:
			out="schlafen";
			break;
		case 1:
			out="gehen";
			break;
		case 2:
			out="laufen";
			break;
		default:
			out="Action not defined";
		
		}
		
		return out;
	}
	
	
	//Main-Methode
	public static void main(String[] args){
		
		
		//Mglichkeiten das Interface zu implementieren und zu nutzen:
		
		// 1.: ber die implementierende Klasse HundImpl
		IHund hund1 = new HundImpl(120);
		HundImpl hund2 = new HundImpl(90);
		
		
		// 2.: ber Lambda-Ausdrcke bei Funktionsinterface: Beispiel DooferHund
		DooferHund doofi = (int groesse) -> {
			
			if(groesse>=100) System.out.println("Wau");
			else
				System.out.println("wuff");
			
		};
		
		// 3.: ber anonyme innerer KLasse:
		IHund hund4 = new IHund() {
			
			// Hier ist der Nachteil, dass wir fr die anonyme Klasse eine Instanzvariable anlegen mssen, die einen festen (Hardcoded) Wert besitzt.
			// Das macht hier eigtl. wenig Sinn. Da ist eine eigene implementierende Klasse besser.
			// In der Praxis braucht man aber hufiger einzelne gezielte Implementierungen von Interfaces, die man dann bequem und direkt dort implementieren kann, ohne eine eigene Klasse schreiben zu mssen.
			// Bekannte Beispiele sind Runnables fr Threads oder Eventlistener bei graphischen Anwendungen. 
			
			private int groesse = 100; 
			
			@Override
			public String doAction(int action) {
				
				String out ="";
				
				switch(action){
				case 0:
					out="schlafen";
					break;
				case 1:
					out="gehen";
					break;
				case 2:
					out="laufen";
					break;
				default:
					out="Action not defined";
				
				}
				
				return out;
			}
			
			@Override
			public void bellen() {
				if(this.groesse>=100)System.out.println("Wau");
				else System.out.println("wuff");
			}
		}; // Ende der anoymen Klasse. ; nicht vergessen 
	
		//Methodenaufrufe
		
		hund1.bellen();
		hund2.bellen();
		doofi.bellen(34);
		hund4.bellen();
	}
	
	
}
